//The Name Generator Library, by Kunark.


/*
Make sure you include it by either checking it in your "Lib"
folder in your file tree, or simply put this in one fo your files:

#include <kunark\namegenerator>



Here is the format:


  Generate_Name(Number_of_Syllables)



Yes, it is just that simple!








Here is an example:

  var/Name = Generate_Name(3)



That would generate a name 3 syllables long.




Look at demo.dm for another example, and compile and run this library to start generating names to see what this can do!
*/





var/list
	SoftConSoft = list("nin","lin","fin","vin","sin","hin","win","nen","non","nun","ner","wer","her","ver","mer","ner","ler","zer","fer","mon","fom","fim","fem","fev","fen","ven","nis","mis","his","lis","ris","wis","vis","ves","res","mes","nes","les","las","has","vas","was","mas","maz","laz","haz","raz","ras","ram","ran","ron","von","nean","mean","vean","kean","lean","loon","rean","roon","wool","weal","wath","rath","wrath","wran","wram","wron","wrun","wrol","wrel","wral","nith","mith","sith","lith","thith","fear","feer","footh","steer","stom","strom","strim","stroll","streth","meth","neth","heth","leth","liss","miss","niss","hiss","nill","mill","hill","fill","fran")
	HardConSoft = list("tin","bin","gin","kin","cin","pin","din","ton","bon","kon","gon","jon","xon","pon","con","cor","dor","gor","jor","kor","tor","ben","ken","ten","pen","cen","gen","jir","bir","kir","gir","gem","dem","kem","tem","pem","jem","xem","ter","ger","per","ber","fer","der","dam","fam","kam","cam","tam","tan","ban","pan","quith","quon","quen","toon","toom","tomb","bomb","gomb","komb","romb","pomb","poon","poom","boom","boon","bean","been","bien","kien","kill","kiss","diss","piss","tiss","giss","biss","bill","pill","till","jill","cill")
	VowConSoft = list("so","no","mo","ho","fo","wo","lo","noo","moo","loo","woo","voo","la","va","na","sa","ra","ma","ha","hi","mi","ni","li","wi","me","ne","se","he","le","ve","we","re","nea","fea","foo","wea","fie","lie","nie","mie","psy")
	SoftConHard = list("nit","vit","hit","wit","sit","lit","let","ret","met","net","vet","mot","not","sot","rot","hot","lot","fot","vot","wot","lib","sib","nib","mib","mob","nob","sob","wob","lob","hop","mop","nop","fop","lop","rop","vop","xop","rip","nip","hip","lip","xip","vip","vok","nok","lok","fok","wok","mok","hok","mik","sik","hik","lik","nik","rik","wik","nak","rak","gak","sak","lak","mak","wak","vak","hig","nig","mig","lig","wig","heg","neg","leg","meg")
	HardConHard = list("tot","bot","got","dot","kot","cot","pot","jot","tok","bok","gok","dok","kok","cok","pok","jok","tob","bob","gob","dob","kob","cob","pob","job","tog","bog","gog","dog","kog","cog","pog","jog","tid","bid","gid","did","kid","cid","pid","jid","ted","bed","ged","ded","ked","ced","ped","jed","tuk","buk","guk","lud","pud","bud","tig","big","gig","lig","pig","jig","cig","kig","dig","bag","hag","sag","nag","lag","jag","mag","nak","lak","sak","tak","hak","jak","bak")
	VowConHard = list("to","bo","ko","go","jo","xo","co","po","ti","bi","ki","gi","ji","xi","ci","pi","te","be","ke","ge","je","ce","pe","tu","bu","ku","ju","cu","pu","ta","ba","ka","ga","ja","ca","pa","pui","qui","boo","coo","doo","koo","pea","bea","kea")
	SoftVow = list("os","on","om","or","ol","en","em","es","el","er","ef","of","af","ar","al","an","am","av","as","im","in","ir","iw","il","if","iv","uf","ul","um","un","ean","ein","eam","ien","ies","iel","ien","iem","aim","ain","ail","air","aiv","aith","eth","ith","oom","oon","ool","aph","iph","eph")
	HardVow = list("ot","ob","og","ok","oc","op","it","ib","ig","ik","ic","ip","et","eb","eg","ec","ep","ek","ak","at","ab","ap","ac","ag","ad","ed","od","id","eat","iet","ait","iak","aik","eak","iap","ack","ick","ock","oock","alk","ey","y")
	L_SCS = list("SV","HV","HCH","HCS","VCH")
	L_HCH = list("SV","HV","SCH","SCS","VCS")
	L_HCS = list("SV","HV","HCH","HCS","VCH")
	L_SCH = list("SV","HV","SCH","SCS","VCS")
	L_VCS = list("SCH","SCS","VCS","HCH","HCS","VCH")
	L_VCH = list("SCH","SCS","VCS","HCH","HCS","VCH")
	L_SV = list("HCH","HCS","VCH")
	L_HV = list("SCH","SCS","VCS")






proc/Get_Next_Syll_Type(A)
	switch(A)
		if("SCS")
			return pick(L_SCS)
		if("HCH")
			return pick(L_HCH)
		if("HCS")
			return pick(L_HCS)
		if("SCH")
			return pick(L_SCH)
		if("VCS")
			return pick(L_VCS)
		if("VCH")
			return pick(L_VCH)
		if("SV")
			return pick(L_SV)
		if("HV")
			return pick(L_HV)

proc/Get_Next_Syll(A)
	switch(A)
		if("SCS")
			return pick(SoftConSoft)
		if("HCH")
			return pick(HardConHard)
		if("HCS")
			return pick(HardConSoft)
		if("SCH")
			return pick(SoftConHard)
		if("VCS")
			return pick(VowConSoft)
		if("VCH")
			return pick(VowConHard)
		if("SV")
			return pick(SoftVow)
		if("HV")
			return pick(HardVow)


proc/Generate_Name(S)   //S = Number of syllables.
	if(S > 0)
		var/G = S-1
		var/F_Current = pick("SCH","SCS","VCS","HCH","HCS","VCH","HV","SV")
		var/Word = Get_Next_Syll(F_Current)
		while(G > 0)
			G--
			F_Current = Get_Next_Syll_Type(F_Current)
			Word += Get_Next_Syll(F_Current)
		Word = "[uppertext(copytext(Word,1,2))][copytext(Word,2)]"
		return Word
	else
		return ""















